<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: BLERemoteService.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BLERemoteService.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * BLERemoteService.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Jul 8, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_BLEREMOTESERVICE_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_BLEREMOTESERVICE_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;sdkconfig.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#if defined(CONFIG_BT_ENABLED)</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;BLEClient.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;BLERemoteCharacteristic.h&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;BLEUUID.h&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;FreeRTOS.h&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span>BLEClient;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">class </span>BLERemoteCharacteristic;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">class </span>BLERemoteService {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">virtual</span> ~BLERemoteService();</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="comment">// Public methods</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    BLERemoteCharacteristic* getCharacteristic(<span class="keyword">const</span> <span class="keywordtype">char</span>* uuid);     <span class="comment">// Get the specified characteristic reference.</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    BLERemoteCharacteristic* getCharacteristic(BLEUUID uuid);       <span class="comment">// Get the specified characteristic reference.</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    BLERemoteCharacteristic* getCharacteristic(uint16_t uuid);      <span class="comment">// Get the specified characteristic reference.</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    std::map&lt;std::string, BLERemoteCharacteristic*&gt;* getCharacteristics();</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    std::map&lt;uint16_t, BLERemoteCharacteristic*&gt;* getCharacteristicsByHandle();  <span class="comment">// Get the characteristics map.</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">void</span> getCharacteristics(std::map&lt;uint16_t, BLERemoteCharacteristic*&gt;* pCharacteristicMap);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    BLEClient*               getClient(<span class="keywordtype">void</span>);                                           <span class="comment">// Get a reference to the client associated with this service.</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    uint16_t                 getHandle();                                               <span class="comment">// Get the handle of this service.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    BLEUUID                  getUUID(<span class="keywordtype">void</span>);                                             <span class="comment">// Get the UUID of this service.</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    std::string              getValue(BLEUUID characteristicUuid);                      <span class="comment">// Get the value of a characteristic.</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span>                     setValue(BLEUUID characteristicUuid, std::string value);   <span class="comment">// Set the value of a characteristic.</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    std::string              toString(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">// Private constructor ... never meant to be created by a user application.</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    BLERemoteService(esp_gatt_id_t srvcId, BLEClient* pClient, uint16_t startHandle, uint16_t endHandle);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment">// Friends</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLEClient;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span>BLERemoteCharacteristic;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">// Private methods</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span>                retrieveCharacteristics(<span class="keywordtype">void</span>);   <span class="comment">// Retrieve the characteristics from the BLE Server.</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    esp_gatt_id_t*      getSrvcId(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    uint16_t            getStartHandle();                <span class="comment">// Get the start handle for this service.</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    uint16_t            getEndHandle();                  <span class="comment">// Get the end handle for this service.</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">void</span>                gattClientEventHandler(</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        esp_gattc_cb_event_t      event,</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        esp_gatt_if_t             gattc_if,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        esp_ble_gattc_cb_param_t* evtParam);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span>                removeCharacteristics();</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// Properties</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="comment">// We maintain a map of characteristics owned by this service keyed by a string representation of the UUID.</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    std::map&lt;std::string, BLERemoteCharacteristic*&gt; m_characteristicMap;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="comment">// We maintain a map of characteristics owned by this service keyed by a handle.</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    std::map&lt;uint16_t, BLERemoteCharacteristic*&gt; m_characteristicMapByHandle;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">bool</span>                m_haveCharacteristics; <span class="comment">// Have we previously obtained the characteristics.</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    BLEClient*          m_pClient;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a> m_semaphoreGetCharEvt = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;GetCharEvt&quot;</span>);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    esp_gatt_id_t       m_srvcId;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    BLEUUID             m_uuid;             <span class="comment">// The UUID of this service.</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    uint16_t            m_startHandle;      <span class="comment">// The starting handle of this service.</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    uint16_t            m_endHandle;        <span class="comment">// The ending handle of this service.</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}; <span class="comment">// BLERemoteService</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* CONFIG_BT_ENABLED */</span><span class="preprocessor"></span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_BLEREMOTESERVICE_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
